-----------------------------------------------------------------------------------------------
-- Client Lua Script for HideInterfaceButton
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- HideInterfaceButton Module Definition
-----------------------------------------------------------------------------------------------
local HideInterfaceButton = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function HideInterfaceButton:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function HideInterfaceButton:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		"InterfaceMenuList",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
	Apollo.RegisterEventHandler("HideInterfaceButton_ShowHide", "OnInterfaceMenuShowHide", self)
end
 
-----------------------------------------------------------------------------------------------
-- HideInterfaceButton OnLoad
-----------------------------------------------------------------------------------------------
function HideInterfaceButton:OnLoad()
	Apollo.RegisterEventHandler("HideInterfaceButton_ShowHide", "OnInterfaceMenuShowHide", self)
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
	Apollo.RegisterSlashCommand("interfacemenu", "OnInterfaceMenuShowHide", self)
	Apollo.RegisterSlashCommand("im", "OnInterfaceMenuShowHide", self)
end

-----------------------------------------------------------------------------------------------
-- HideInterfaceButton Functions
-----------------------------------------------------------------------------------------------

function HideInterfaceButton:OnInterfaceMenuListHasLoaded()

	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Show Interface Menu",
		{ "HideInterfaceButton_ShowHide", "", "" } ) 
		
	local interfaceMenuAddon = Apollo.GetAddon("InterfaceMenuList")
	if interfaceMenuAddon.wndMain then
		--interfaceMenuAddon["wndList"]:FindChild("FullListFrame"):SetAnchorOffsets(30, -719, 410, -20)
		interfaceMenuAddon["wndMain"]:FindChild("OpenFullListBtn"):SetOpacity(0)
	end	
end

function HideInterfaceButton:OnInterfaceMenuShowHide() 
	local interfaceMenuAddon = Apollo.GetAddon("InterfaceMenuList")
	if interfaceMenuAddon.wndMain then	
		interfaceMenuAddon["wndList"]:FindChild("FullListFrame"):Show(true)
		--interfaceMenuAddon["wndList"]:FindChild("SearchEditBox"):SetFocus() -- It's annoying
		interfaceMenuAddon:FullListRedraw()
	end
end

-----------------------------------------------------------------------------------------------
-- HideInterfaceButton Instance
-----------------------------------------------------------------------------------------------
local HideInterfaceButtonInst = HideInterfaceButton:new()
HideInterfaceButtonInst:Init()
